<?php
define('FREEPBX_IS_AUTH', 'TRUE');
define("AMP_CONF", "/etc/amportal.conf");
$amportalconf = AMP_CONF;

function parse_amportal_conf_bootstrap($filename) {
        $file = file($filename);
        foreach ($file as $line) {
                if (preg_match("/^\s*([\w]+)\s*=\s*\"?([\w\/\:\.\*\%-]*)\"?\s*([;#].*)?/",$line,$matches)) {
                        $conf[ $matches[1] ] = $matches[2];
                }
        }
        if ( !isset($conf["AMPWEBROOT"]) || ($conf["AMPWEBROOT"] == "")) {
                $conf["AMPWEBROOT"] = "/var/www/html";
        } else {
                $conf["AMPWEBROOT"] = rtrim($conf["AMPWEBROOT"],'/');
        }

        return $conf;
}
include('DB.php');
$amp_conf = parse_amportal_conf_bootstrap($amportalconf);
require_once($amp_conf['AMPWEBROOT']."/admin/functions.inc.php");
require_once($amp_conf['AMPWEBROOT']."/admin/modules/core/functions.inc.php");
require_once($amp_conf['AMPWEBROOT']."/admin/modules/queues/functions.inc.php");
$amp_conf = parse_amportal_conf($amportalconf);

$db_engine = "mysql";
if (isset($amp_conf["AMPDBENGINE"])){
        $db_engine = $amp_conf["AMPDBENGINE"];
}

switch ($db_engine)
{
        case "pgsql":
        case "mysql":
                /* datasource in in this style:
                dbengine://username:password@host/database */

                $db_user = $amp_conf["AMPDBUSER"];
                $db_pass = $amp_conf["AMPDBPASS"];
                $db_host = $amp_conf["AMPDBHOST"];
                $db_name = $amp_conf["AMPDBNAME"];

                $datasource = $db_engine.'://'.$db_user.':'.$db_pass.'@'.$db_host.'/'.$db_name;
                $db = DB::connect($datasource); // attempt connection
                break;

        case "sqlite":
                die_freepbx("SQLite2 support is deprecated. Please use sqlite3 only.");
                break;

        case "sqlite3":
                if (!isset($amp_conf["AMPDBFILE"]))
                        fatal("You must setup properly AMPDBFILE in $amportalconf");

                if (isset($amp_conf["AMPDBFILE"]) == "")
                        fatal("AMPDBFILE in $amportalconf cannot be blank");

                /* on centos this extension is not loaded by default */
                if (! extension_loaded('sqlite3.so')  && ! extension_loaded('SQLITE3'))
                        dl('sqlite3.so');

                if (! @require_once('DB/sqlite3.php') )
                {
                        die_freepbx("Your PHP installation has no PEAR/SQLite3 support. Please install php-sqlite3 and php-pear.");
                }

                require_once('DB/sqlite3.php');
                $datasource = "sqlite3:///" . $amp_conf["AMPDBFILE"] . "?mode=0666";
                $db = DB::connect($datasource);
                break;

        default:
                fatal( "Unknown SQL engine: [$db_engine]");
}

switch ($argv[1]) {
    case "install":
        _module_setenabled("fop2admin",1);
        _module_runscripts("fop2admin","install");
        break;
    case "uninstall":
        _module_setenabled("fop2admin",0);
        _module_runscripts("fop2admin","uninstall");

}

?>
